#include <iostream>
#include <thread>
#include <boost/asio.hpp>

int main()
{
    constexpr int c_num_threads = 3;
    boost::asio::io_context ctx;

    for (int i = 0; i < c_num_threads; i++)
    {
        boost::asio::post(ctx, [](){
            std::this_thread::sleep_for(std::chrono::seconds{1});
            std::cerr << "hi!\n";
        });
    }

    boost::asio::thread_pool th{c_num_threads};
    for (int i = 0; i < c_num_threads; i++)
        boost::asio::post(th, [&ctx](){ ctx.run(); });

    th.join();

    return EXIT_SUCCESS;
}
